section \<open>Multiset as quotient type over list\<close>

theory Multiset_Quotient
imports Main
begin

subsection \<open>Auxiliary notation\<close>

text \<open>
  Readable notation for lifting combinators,
  see @{file "~~/src/HOL/Transfer.thy"}
\<close>

notation rel_fun (infixr "\<^bold>\<Longrightarrow>" 55)
notation map_fun (infixr "\<^bold>\<Rightarrow>" 55)


subsection \<open>Counting occurrences of elements\<close>

fun count :: "'a \<Rightarrow> 'a list \<Rightarrow> nat"  ("\<sharp>_'(_')")
where
  "\<sharp>x([]) = 0"
| "\<sharp>x(y#ys) = (if x = y then Suc (\<sharp>x(ys)) else \<sharp>x(ys))"

lemma count_append: "\<sharp>x(xs @ ys) = \<sharp>x(xs) + \<sharp>x(ys)"
  by (induct xs) auto


subsection \<open>Exercise: Quotient type definition\<close>

text \<open>
  \<triangleright> Define @{term "list_equiv :: 'a list \<Rightarrow> 'a list \<Rightarrow> bool"}
    to identify lists according the the multiplicity of
    each element, ignoring order of occurrence.

  \<triangleright> Define a type constructor @{text "'a mset"} as quotient of
    @{typ "'a list"}, using the command 'quotient_type'.
\<close>


subsection \<open>Exercise: type class instantiation\<close>

text \<open>
  \<triangleright> Establish the following type class instantiation:

    instantiation mset :: (linorder) monoid_add
    begin
      ...
    end

  Hint: define zero_mset and plus_mset via 'lift_definition',
  and finish the 'instance' proof.
\<close>

end
